/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.exception;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.decode.ComposableDecoder;
import org.fortiss.af3.exploration.alg.service.IExplorationEncoding;

/**
 * Exception to be thrown whenever a some dependency in the DSE cannot be satisfied
 * 
 * @author diewald
 */
public class MissingDependencyException extends DependencyException {

	/** Constructor for missing dependencies of {@link ComposableDecoder}s. */
	public MissingDependencyException(ComposableDecoder<?, ?> dec,
			Class<? extends IExplorationEncoding> enc, String msg) {
		super(
				"The encoding " +
						enc.getSimpleName() +
						" required by the decoder " +
						dec.getClass().getSimpleName() +
						"could not be found. Please check if all required encodings are available, and that the dependencies are correctly defined. Details: " +
						msg);
	}
}
